Skip to main content

Update subject compatibility level

PUT 

/config/:subject

Update compatibility level, compatibility group, normalization, default metadata, and rule set for the specified subject. On success, echoes the original request back to the client.

Request

Responses

The original request.

OpenAPI definition (YAML)
paths:
  /config/{subject}:
    put:
      tags:
      - Config (v1)
      description: 'Update compatibility level, compatibility group, normalization,

        default metadata, and rule set for the specified subject. On success,

        echoes the original request back to the client.'
      operationId: updateSubjectLevelConfig
      parameters:
      - name: subject
        in: path
        description: Name of the subject
        required: true
        schema:
          type: string
      requestBody:
        description: Config Update Request
        content:
          application/vnd.schemaregistry.v1+json:
            schema:
              type: object
              properties:
                alias:
                  type: string
                  description: 'If alias is specified, then this subject is an alias for the subject

                    named by the alias. That means that any reference to this subject

                    will be replaced by the alias.'
                normalize:
                  type: boolean
                  description: 'If true, then schemas are automatically normalized when registered

                    or when passed during lookups. This means that clients do not have

                    to pass the "normalize" query parameter to have normalization occur.'
                compatibility:
                  type: string
                  description: Compatibility Level
                  example: FULL_TRANSITIVE
                  enum:
                  - BACKWARD
                  - BACKWARD_TRANSITIVE
                  - FORWARD
                  - FORWARD_TRANSITIVE
                  - FULL
                  - FULL_TRANSITIVE
                  - NONE
                compatibilityGroup:
                  type: string
                  description: 'Only schemas that belong to the same compatibility group will be

                    checked for compatibility.'
                defaultMetadata:
                  type: object
                  description: Default value for the metadata to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                overrideMetadata:
                  type: object
                  description: Override value for the metadata to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                defaultRuleSet:
                  type: object
                  description: Default value for the ruleSet to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                overrideRuleSet:
                  type: object
                  description: Override value for the ruleSet to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
              description: Config update request
              title: ConfigUpdateRequest
          application/vnd.schemaregistry+json:
            schema:
              type: object
              properties:
                alias:
                  type: string
                  description: 'If alias is specified, then this subject is an alias for the subject

                    named by the alias. That means that any reference to this subject

                    will be replaced by the alias.'
                normalize:
                  type: boolean
                  description: 'If true, then schemas are automatically normalized when registered

                    or when passed during lookups. This means that clients do not have

                    to pass the "normalize" query parameter to have normalization occur.'
                compatibility:
                  type: string
                  description: Compatibility Level
                  example: FULL_TRANSITIVE
                  enum:
                  - BACKWARD
                  - BACKWARD_TRANSITIVE
                  - FORWARD
                  - FORWARD_TRANSITIVE
                  - FULL
                  - FULL_TRANSITIVE
                  - NONE
                compatibilityGroup:
                  type: string
                  description: 'Only schemas that belong to the same compatibility group will be

                    checked for compatibility.'
                defaultMetadata:
                  type: object
                  description: Default value for the metadata to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                overrideMetadata:
                  type: object
                  description: Override value for the metadata to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                defaultRuleSet:
                  type: object
                  description: Default value for the ruleSet to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                overrideRuleSet:
                  type: object
                  description: Override value for the ruleSet to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
              description: Config update request
              title: ConfigUpdateRequest
          application/json:
            schema:
              type: object
              properties:
                alias:
                  type: string
                  description: 'If alias is specified, then this subject is an alias for the subject

                    named by the alias. That means that any reference to this subject

                    will be replaced by the alias.'
                normalize:
                  type: boolean
                  description: 'If true, then schemas are automatically normalized when registered

                    or when passed during lookups. This means that clients do not have

                    to pass the "normalize" query parameter to have normalization occur.'
                compatibility:
                  type: string
                  description: Compatibility Level
                  example: FULL_TRANSITIVE
                  enum:
                  - BACKWARD
                  - BACKWARD_TRANSITIVE
                  - FORWARD
                  - FORWARD_TRANSITIVE
                  - FULL
                  - FULL_TRANSITIVE
                  - NONE
                compatibilityGroup:
                  type: string
                  description: 'Only schemas that belong to the same compatibility group will be

                    checked for compatibility.'
                defaultMetadata:
                  type: object
                  description: Default value for the metadata to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                overrideMetadata:
                  type: object
                  description: Override value for the metadata to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                defaultRuleSet:
                  type: object
                  description: Default value for the ruleSet to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                overrideRuleSet:
                  type: object
                  description: Override value for the ruleSet to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
              description: Config update request
              title: ConfigUpdateRequest
          application/octet-stream:
            schema:
              type: object
              properties:
                alias:
                  type: string
                  description: 'If alias is specified, then this subject is an alias for the subject

                    named by the alias. That means that any reference to this subject

                    will be replaced by the alias.'
                normalize:
                  type: boolean
                  description: 'If true, then schemas are automatically normalized when registered

                    or when passed during lookups. This means that clients do not have

                    to pass the "normalize" query parameter to have normalization occur.'
                compatibility:
                  type: string
                  description: Compatibility Level
                  example: FULL_TRANSITIVE
                  enum:
                  - BACKWARD
                  - BACKWARD_TRANSITIVE
                  - FORWARD
                  - FORWARD_TRANSITIVE
                  - FULL
                  - FULL_TRANSITIVE
                  - NONE
                compatibilityGroup:
                  type: string
                  description: 'Only schemas that belong to the same compatibility group will be

                    checked for compatibility.'
                defaultMetadata:
                  type: object
                  description: Default value for the metadata to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                overrideMetadata:
                  type: object
                  description: Override value for the metadata to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                defaultRuleSet:
                  type: object
                  description: Default value for the ruleSet to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
                overrideRuleSet:
                  type: object
                  description: Override value for the ruleSet to be used during schema registration.
                  properties:
                    properties:
                      type: object
                      description: The metadata properties and their new values
              description: Config update request
              title: ConfigUpdateRequest
        required: true
      responses:
        '200':
          description: The original request.
          content:
            application/vnd.schemaregistry.v1+json:
              schema:
                type: object
                properties:
                  alias:
                    type: string
                    description: 'If alias is specified, then this subject is an alias for the subject

                      named by the alias. That means that any reference to this subject

                      will be replaced by the alias.'
                  normalize:
                    type: boolean
                    description: 'If true, then schemas are automatically normalized when registered

                      or when passed during lookups. This means that clients do not have

                      to pass the "normalize" query parameter to have normalization occur.'
                  compatibility:
                    type: string
                    description: Compatibility Level
                    example: FULL_TRANSITIVE
                    enum:
                    - BACKWARD
                    - BACKWARD_TRANSITIVE
                    - FORWARD
                    - FORWARD_TRANSITIVE
                    - FULL
                    - FULL_TRANSITIVE
                    - NONE
                  compatibilityGroup:
                    type: string
                    description: 'Only schemas that belong to the same compatibility group will be

                      checked for compatibility.'
                  defaultMetadata:
                    type: object
                    description: Default value for the metadata to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                  overrideMetadata:
                    type: object
                    description: Override value for the metadata to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                  defaultRuleSet:
                    type: object
                    description: Default value for the ruleSet to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                  overrideRuleSet:
                    type: object
                    description: Override value for the ruleSet to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                description: Config update request
                title: ConfigUpdateRequest
            application/vnd.schemaregistry+json; qs=0.9:
              schema:
                type: object
                properties:
                  alias:
                    type: string
                    description: 'If alias is specified, then this subject is an alias for the subject

                      named by the alias. That means that any reference to this subject

                      will be replaced by the alias.'
                  normalize:
                    type: boolean
                    description: 'If true, then schemas are automatically normalized when registered

                      or when passed during lookups. This means that clients do not have

                      to pass the "normalize" query parameter to have normalization occur.'
                  compatibility:
                    type: string
                    description: Compatibility Level
                    example: FULL_TRANSITIVE
                    enum:
                    - BACKWARD
                    - BACKWARD_TRANSITIVE
                    - FORWARD
                    - FORWARD_TRANSITIVE
                    - FULL
                    - FULL_TRANSITIVE
                    - NONE
                  compatibilityGroup:
                    type: string
                    description: 'Only schemas that belong to the same compatibility group will be

                      checked for compatibility.'
                  defaultMetadata:
                    type: object
                    description: Default value for the metadata to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                  overrideMetadata:
                    type: object
                    description: Override value for the metadata to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                  defaultRuleSet:
                    type: object
                    description: Default value for the ruleSet to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                  overrideRuleSet:
                    type: object
                    description: Override value for the ruleSet to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                description: Config update request
                title: ConfigUpdateRequest
            application/json; qs=0.5:
              schema:
                type: object
                properties:
                  alias:
                    type: string
                    description: 'If alias is specified, then this subject is an alias for the subject

                      named by the alias. That means that any reference to this subject

                      will be replaced by the alias.'
                  normalize:
                    type: boolean
                    description: 'If true, then schemas are automatically normalized when registered

                      or when passed during lookups. This means that clients do not have

                      to pass the "normalize" query parameter to have normalization occur.'
                  compatibility:
                    type: string
                    description: Compatibility Level
                    example: FULL_TRANSITIVE
                    enum:
                    - BACKWARD
                    - BACKWARD_TRANSITIVE
                    - FORWARD
                    - FORWARD_TRANSITIVE
                    - FULL
                    - FULL_TRANSITIVE
                    - NONE
                  compatibilityGroup:
                    type: string
                    description: 'Only schemas that belong to the same compatibility group will be

                      checked for compatibility.'
                  defaultMetadata:
                    type: object
                    description: Default value for the metadata to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                  overrideMetadata:
                    type: object
                    description: Override value for the metadata to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                  defaultRuleSet:
                    type: object
                    description: Default value for the ruleSet to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                  overrideRuleSet:
                    type: object
                    description: Override value for the ruleSet to be used during schema registration.
                    properties:
                      properties:
                        type: object
                        description: The metadata properties and their new values
                description: Config update request
                title: ConfigUpdateRequest
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                type: object
                properties:
                  error_code:
                    type: integer
                    description: The error code
                    format: int32
                  message:
                    type: string
                    description: The error message
                description: Error message of this operation
                title: ErrorMessage
              example:
                error_code: 400
                message: Bad Request
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                type: object
                properties:
                  error_code:
                    type: integer
                    description: The error code
                    format: int32
                  message:
                    type: string
                    description: The error message
                description: Error message of this operation
                title: ErrorMessage
              example:
                error_code: 401
                message: Unauthorized
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                type: object
                properties:
                  error_code:
                    type: integer
                    description: The error code
                    format: int32
                  message:
                    type: string
                    description: The error message
                description: Error message of this operation
                title: ErrorMessage
              example:
                error_code: 403
                message: Forbidden
        '422':
          description: Unprocessable Entity. Error code 42203 indicates invalid compatibility level.
          content:
            application/vnd.schemaregistry.v1+json:
              schema:
                type: object
                properties:
                  error_code:
                    type: integer
                    description: The error code
                    format: int32
                  message:
                    type: string
                    description: The error message
                description: Error message of this operation
                title: ErrorMessage
            application/vnd.schemaregistry+json; qs=0.9:
              schema:
                type: object
                properties:
                  error_code:
                    type: integer
                    description: The error code
                    format: int32
                  message:
                    type: string
                    description: The error message
                description: Error message of this operation
                title: ErrorMessage
            application/json; qs=0.5:
              schema:
                type: object
                properties:
                  error_code:
                    type: integer
                    description: The error code
                    format: int32
                  message:
                    type: string
                    description: The error message
                description: Error message of this operation
                title: ErrorMessage
        '429':
          description: Rate Limit Exceeded
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
            Retry-After:
              schema:
                type: integer
              description: The number of seconds to wait until the rate limit window resets. Only sent
                when the rate limit is reached.
        '500':
          description: Internal Server Error. Error code 50001 indicates a failure in the backend data
            store. Error code 50003 indicates a failure forwarding the request to the primary.
          content:
            application/vnd.schemaregistry.v1+json:
              schema:
                type: object
                properties:
                  error_code:
                    type: integer
                    description: The error code
                    format: int32
                  message:
                    type: string
                    description: The error message
                description: Error message of this operation
                title: ErrorMessage
            application/vnd.schemaregistry+json; qs=0.9:
              schema:
                type: object
                properties:
                  error_code:
                    type: integer
                    description: The error code
                    format: int32
                  message:
                    type: string
                    description: The error message
                description: Error message of this operation
                title: ErrorMessage
            application/json; qs=0.5:
              schema:
                type: object
                properties:
                  error_code:
                    type: integer
                    description: The error code
                    format: int32
                  message:
                    type: string
                    description: The error message
                description: Error message of this operation
                title: ErrorMessage
      security:
      - resource-api-key: []
      - external-access-token: []
      servers:
      - url: https://psrc-00000.region.provider.confluent.cloud
        description: Confluent Cloud Schema Registry Endpoint.
      jsonRequestBodyExample:
        alias: string
        normalize: true
        compatibility: FULL_TRANSITIVE
        compatibilityGroup: string
        defaultMetadata:
          properties: {}
        overrideMetadata:
          properties: {}
        defaultRuleSet:
          properties: {}
        overrideRuleSet:
          properties: {}